unit Delta.Methods;

interface

uses System.SysUtils, System.Classes, System.rtti, System.TypInfo;

function executeClassMethod(const AQualifiedName, AName: string;
  const Args: array of TValue): TValue;

function executeClassMethodReturnIntArgsNone(const AQualifiedName,
  AName: PAnsiChar): Integer; stdcall;

function executeClassMethodReturnReferenceArgsNone(const AQualifiedName,
  AName: PAnsiChar): Integer; stdcall;

// constructor TBitmap.CreateFromFile(const AFileName: string);
function executeClassMethodReturnReferenceArgsString(const AQualifiedName,
  AName, AValue: PAnsiChar): Integer; stdcall;

procedure executeClassMethodReturnNoneArgsString(const AQualifiedName,
  AName: PAnsiChar; const value: WideString); stdcall;

procedure executeClassMethodReturnNoneArgsNone(const AQualifiedName,
  AName: PAnsiChar); stdcall;

procedure executeClassMethodReturnNoneArgsStringStringString_Out_String
  (const AQualifiedName, AName: PAnsiChar; const v1, v2, v3: WideString;
  out value: WideString); stdcall;

procedure executeInstanceMethodReturnEnumArgsNone(const Reference: Integer;
  const AName: PAnsiChar; out value: WideString); stdcall;

function executeClassMethodReturnReferenceArgsReference(const AQualifiedName,
  AName: PAnsiChar; const Reference: Integer): Integer; stdcall;

function executeClassMethodReturnReferenceArgsIntUInt(const AQualifiedName,
  AName: PAnsiChar; I1: Integer; I2: Cardinal): Integer; stdcall;

function executeClassMethodReturnReferenceArgsReferenceInt(const AQualifiedName,
  AName: PAnsiChar; const Reference, I: Integer): Integer; stdcall;

function executeInstanceMethod(const Reference: Integer; const AName: string;
  const Args: array of TValue): TValue;

procedure executeInstanceMethodReturnNoneArgsNone(const Reference: Integer;
  const AName: PAnsiChar); stdcall;

procedure executeInstanceMethodReturnNoneArgsReference(const Reference: Integer;
  const AName: PAnsiChar; Reference2: Integer); stdcall;

procedure executeInstanceMethodReturnNoneArgsStructFloat(const Reference
  : Integer; const AName: PAnsiChar; Reference2: Integer;
  s: Single); stdcall;

procedure executeInstanceMethodReturnNoneArgsStructStructFloat(const Reference
  : Integer; const AName: PAnsiChar; Reference2, Reference3: Integer;
  s: Single); stdcall;

procedure executeInstanceMethodReturnNoneArgsStructStructFloatReference(const Reference
  : Integer; const AName: PAnsiChar; Reference2, Reference3: Integer;
  s: Single; Reference4: Integer); stdcall;

procedure executeInstanceMethodReturnNoneArgsReferenceFloat(const Reference: Integer;
  const AName: PAnsiChar; Reference2: Integer; s: Single); stdcall;

// procedure TCanvas.DrawBitmap(const ABitmap: TBitmap; const SrcRect, DstRect: TRectF; const AOpacity: Single; const HighSpeed: Boolean);
procedure executeInstanceMethodReturnNoneArgsReferenceStructStructFloatBoolean(const Reference
  : Integer; const AName: PAnsiChar; Reference2, Reference3, Reference4: Integer;
  s: Single; B: Boolean); stdcall;

procedure executeInstanceMethodReturnNoneArgsFloatFloatFloatFloatFloat
  (const Reference: Integer; const AName: PAnsiChar;
  s1, s2, s3, s4, s5: Single); stdcall;

procedure executeInstanceMethodReturnNoneArgsString(const Reference
  : Integer; const AName, AValue: PAnsiChar); stdcall;

function executeInstanceMethodReturnIntArgsNone(const Reference: Integer;
  const AName: PAnsiChar): Integer; stdcall;

function executeInstanceMethodReturnBoolArgsNone(const Reference: Integer;
  const AName: PAnsiChar): Boolean; stdcall;

function executeInstanceMethodReturnReferenceArgsNone(const Reference: Integer;
  const AName: PAnsiChar): Integer; stdcall;

// function TComponent.FindComponent(const AName: string): TComponent;
function executeInstanceMethodReturnReferenceArgsString(const Reference
  : Integer; const AName, AValue: PAnsiChar): Integer; stdcall;

function executeInstanceMethodReturnReferenceArgsInt(const Reference: Integer;
  const AName: PAnsiChar; const R: Integer): Integer; stdcall;

function executeInstanceMethodReturnIntArgsString(const Reference: Integer;
  const AName, AValue: PAnsiChar): Integer; stdcall;

function executeInstanceMethodReturnIntArgsStringReference(const Reference
  : Integer; const AName, AValue: PAnsiChar; const R: Integer)
  : Integer; stdcall;

procedure executeInstanceMethodReturnStringArgsNone_Out_String
  (const Reference: Integer; const AName: PAnsiChar; out value: WideString); stdcall;

exports executeInstanceMethodReturnNoneArgsNone,
  executeInstanceMethodReturnReferenceArgsNone,
  executeClassMethodReturnReferenceArgsString,
  executeInstanceMethodReturnIntArgsNone,
  executeInstanceMethodReturnBoolArgsNone,
  executeInstanceMethodReturnIntArgsString,
  executeInstanceMethodReturnIntArgsStringReference,
  executeClassMethodReturnReferenceArgsNone,
  executeClassMethodReturnNoneArgsStringStringString_Out_String,
  executeInstanceMethodReturnReferenceArgsString,
  executeClassMethodReturnReferenceArgsReference,
  executeInstanceMethodReturnNoneArgsStructFloat,
  executeInstanceMethodReturnNoneArgsReferenceFloat,
  executeInstanceMethodReturnNoneArgsStructStructFloat,
  executeInstanceMethodReturnNoneArgsStructStructFloatReference,
  executeInstanceMethodReturnNoneArgsFloatFloatFloatFloatFloat,
  executeInstanceMethodReturnNoneArgsString,
  executeInstanceMethodReturnNoneArgsReferenceStructStructFloatBoolean,
  executeClassMethodReturnReferenceArgsReferenceInt,
  executeClassMethodReturnReferenceArgsIntUInt,
  executeInstanceMethodReturnNoneArgsReference,
  executeClassMethodReturnNoneArgsString,
  executeClassMethodReturnNoneArgsNone,
  executeInstanceMethodReturnEnumArgsNone,
  executeInstanceMethodReturnReferenceArgsInt,
  executeInstanceMethodReturnStringArgsNone_Out_String;

implementation

function executeClassMethod(const AQualifiedName, AName: string;
  const Args: array of TValue): TValue;
var
  context: TRttiContext;
  instType: TRttiInstanceType;
begin
  context := TRttiContext.Create;
  try
    try
      instType := (context.FindType(AQualifiedName) as TRttiInstanceType);
      result := instType.GetMethod(AName).Invoke(instType.MetaclassType, Args);
    except
      on E: Exception do
        writeln(E.ClassName + ' error raised, with message : ' + E.Message);
    end;

  finally
    context.Free;
  end;
end;

function executeClassMethodReturnIntArgsNone(const AQualifiedName,
  AName: PAnsiChar): Integer; stdcall;
var
  value: TValue;
begin
  value := executeClassMethod(string(AQualifiedName), string(AName), []);
  result := value.AsInteger;
end;

function executeClassMethodReturnReferenceArgsString(const AQualifiedName,
  AName, AValue: PAnsiChar): Integer; stdcall;
var
  value: TValue;
begin
  value := executeClassMethod(string(AQualifiedName), string(AName), [string(AValue)]);
  result := Integer(value.AsObject);
end;

procedure executeClassMethodReturnNoneArgsString(const AQualifiedName,
  AName: PAnsiChar; const value: WideString); stdcall;
begin
  executeClassMethod(string(AQualifiedName), string(AName), [string(value)]);
end;

procedure executeClassMethodReturnNoneArgsNone(const AQualifiedName,
  AName: PAnsiChar); stdcall;
begin
  executeClassMethod(string(AQualifiedName), string(AName), []);
end;

function executeClassMethodReturnReferenceArgsNone(const AQualifiedName,
  AName: PAnsiChar): Integer; stdcall;
var
  value: TValue;
begin
  value := executeClassMethod(string(AQualifiedName), string(AName), []);
  result := Integer(value.AsObject);
end;

function executeClassMethodReturnReferenceArgsReference(const AQualifiedName,
  AName: PAnsiChar; const Reference: Integer): Integer; stdcall;
var
  value: TValue;
  obj: TObject;
begin
  if Reference = -1 then
    obj := nil
  else
    obj := TObject(Reference);

  value := executeClassMethod(string(AQualifiedName), string(AName), [obj]);
  result := Integer(value.AsObject);
end;

function executeClassMethodReturnReferenceArgsReferenceInt(const AQualifiedName,
  AName: PAnsiChar; const Reference, I: Integer): Integer; stdcall;
var
  value: TValue;
  obj: TObject;
begin
  if Reference = -1 then
    obj := nil
  else
    obj := TObject(Reference);

  value := executeClassMethod(string(AQualifiedName), string(AName), [obj, I]);
  result := Integer(value.AsObject);
end;

function executeClassMethodReturnReferenceArgsIntUInt(const AQualifiedName,
  AName: PAnsiChar; I1: Integer; I2: Cardinal): Integer; stdcall;
var
  value: TValue;
begin
  value := executeClassMethod(string(AQualifiedName), string(AName), [I1, I2]);
  result := Integer(value.AsObject);
end;

function executeInstanceMethod(const Reference: Integer; const AName: string;
  const Args: array of TValue): TValue;
var
  context: TRttiContext;
  instType: TRttiInstanceType;
  obj: TObject;
  meth: TRttiMethod;
begin
  context := TRttiContext.Create;
  try
    try
      obj := TObject(Reference);
      instType := (context.GetType(obj.ClassType) as TRttiInstanceType);
      meth := instType.GetMethod(AName);
      if meth = nil then
        writeln('Class ' + instType.Name + ' does not have method ' + AName )
      else
        result := instType.GetMethod(AName).Invoke(obj, Args);
    except
      on E: Exception do
        writeln(E.ClassName + ' error raised, with message : ' + E.Message);
    end;
  finally
    context.Free;
  end;
end;

procedure executeInstanceMethodReturnNoneArgsNone(const Reference: Integer;
  const AName: PAnsiChar); stdcall;
begin
  executeInstanceMethod(Reference, string(AName), []);
end;

function executeInstanceMethodReturnIntArgsNone(const Reference: Integer;
  const AName: PAnsiChar): Integer; stdcall;
var
  value: TValue;
begin
  value := executeInstanceMethod(Reference, string(AName), []);
  result := Integer(value.AsInteger);
end;

function executeInstanceMethodReturnBoolArgsNone(const Reference: Integer;
  const AName: PAnsiChar): Boolean; stdcall;
var
  value: TValue;
begin
  value := executeInstanceMethod(Reference, string(AName), []);
  result := Boolean(value.AsBoolean);
end;

function executeInstanceMethodReturnReferenceArgsNone(const Reference: Integer;
  const AName: PAnsiChar): Integer; stdcall;
var
  value: TValue;
begin
  value := executeInstanceMethod(Reference, string(AName), []);
  result := Integer(value.AsObject);
end;

procedure executeInstanceMethodReturnNoneArgsReference(const Reference: Integer;
  const AName: PAnsiChar; Reference2: Integer); stdcall;
var
  obj: TObject;
begin
  if Reference2 = -1 then
    obj := nil
  else
    obj := TObject(Reference2);
  executeInstanceMethod(Reference, string(AName), [obj]);
end;

procedure executeInstanceMethodReturnNoneArgsReferenceFloat(const Reference: Integer;
  const AName: PAnsiChar; Reference2: Integer; s: Single); stdcall;
var
  obj: TObject;
begin
  if Reference2 = -1 then
    obj := nil
  else
    obj := TObject(Reference2);
  executeInstanceMethod(Reference, string(AName), [obj, s]);
end;

procedure executeInstanceMethodReturnNoneArgsStructFloat(const Reference
  : Integer; const AName: PAnsiChar; Reference2: Integer;
  s: Single); stdcall;
var
  context: TRttiContext;
  instType: TRttiInstanceType;
  params: TArray<TRttiParameter>;
  obj: TObject;
  Arg1: TValue;
begin
  context := TRttiContext.Create;
  try
    try
      obj := TObject(Reference);
      instType := (context.GetType(obj.ClassType) as TRttiInstanceType);
      params := instType.GetMethod(string(AName)).GetParameters;
      TValue.Make(Pointer(Reference2), params[0].ParamType.Handle, Arg1);
      executeInstanceMethod(Reference, string(AName), [Arg1, s]);
    except
      on E: Exception do
        writeln(E.ClassName + ' error raised, with message : ' + E.Message);
    end;
  finally
    context.Free;
  end;
end;

procedure executeInstanceMethodReturnNoneArgsStructStructFloat(const Reference
  : Integer; const AName: PAnsiChar; Reference2, Reference3: Integer;
  s: Single); stdcall;
var
  context: TRttiContext;
  instType: TRttiInstanceType;
  params: TArray<TRttiParameter>;
  obj: TObject;
  Arg1: TValue;
  Arg2: TValue;
begin
  context := TRttiContext.Create;
  try
    try
      obj := TObject(Reference);
      instType := (context.GetType(obj.ClassType) as TRttiInstanceType);

     // Args[0].ExtractRawData(@p);

      params := instType.GetMethod(string(AName)).GetParameters;

      TValue.Make(Pointer(Reference2), params[0].ParamType.Handle, Arg1);
      TValue.Make(Pointer(Reference3), params[1].ParamType.Handle, Arg2);

      executeInstanceMethod(Reference, string(AName), [Arg1, Arg2, s]);
    except
      on E: Exception do
        writeln(E.ClassName + ' error raised, with message : ' + E.Message);
    end;
  finally
    context.Free;
  end;
end;

procedure executeInstanceMethodReturnNoneArgsStructStructFloatReference(const Reference
  : Integer; const AName: PAnsiChar; Reference2, Reference3: Integer;
  s: Single; Reference4: Integer); stdcall;
var
  context: TRttiContext;
  instType: TRttiInstanceType;
  params: TArray<TRttiParameter>;
  obj: TObject;
  Arg1: TValue;
  Arg2: TValue;
begin
  context := TRttiContext.Create;
  try
    try
      obj := TObject(Reference);
      instType := (context.GetType(obj.ClassType) as TRttiInstanceType);

     // Args[0].ExtractRawData(@p);

      params := instType.GetMethod(string(AName)).GetParameters;

      TValue.Make(Pointer(Reference2), params[0].ParamType.Handle, Arg1);
      TValue.Make(Pointer(Reference3), params[1].ParamType.Handle, Arg2);

      executeInstanceMethod(Reference, string(AName), [Arg1, Arg2, s, TObject(Reference4)]);
    except
      on E: Exception do
        writeln(E.ClassName + ' error raised, with message : ' + E.Message);
    end;
  finally
    context.Free;
  end;
end;

procedure executeInstanceMethodReturnNoneArgsReferenceStructStructFloatBoolean(const Reference
  : Integer; const AName: PAnsiChar; Reference2, Reference3, Reference4: Integer;
  s: Single; B: Boolean); stdcall;
var
  context: TRttiContext;
  instType: TRttiInstanceType;
  params: TArray<TRttiParameter>;
  obj: TObject;
  Arg1: TValue;
  Arg2: TValue;
Begin
  context := TRttiContext.Create;
  try
    try
      obj := TObject(Reference);
      instType := (context.GetType(obj.ClassType) as TRttiInstanceType);
      params := instType.GetMethod(string(AName)).GetParameters;
      TValue.Make(Pointer(Reference3), params[1].ParamType.Handle, Arg1);
      TValue.Make(Pointer(Reference4), params[2].ParamType.Handle, Arg2);

      executeInstanceMethod(Reference, string(AName), [TObject(Reference2), Arg1, Arg2, s, B]);
    except
      on E: Exception do
        writeln(E.ClassName + ' error raised, with message : ' + E.Message);
    end;
  finally
    context.Free;
  end;
End;

procedure executeInstanceMethodReturnNoneArgsString(const Reference
  : Integer; const AName, AValue: PAnsiChar); stdcall;
begin
  executeInstanceMethod(Reference, string(AName), [string(AValue)]);
end;

procedure executeInstanceMethodReturnNoneArgsFloatFloatFloatFloatFloat
  (const Reference: Integer; const AName: PAnsiChar;
  s1, s2, s3, s4, s5: Single); stdcall;
begin
  executeInstanceMethod(Reference, string(AName), [s1, s2, s3, s4, s5]);
end;

function executeInstanceMethodReturnReferenceArgsInt(const Reference: Integer;
  const AName: PAnsiChar; const R: Integer): Integer; stdcall;
var
  value: TValue;
begin
  value := executeInstanceMethod(Reference, string(AName), [R]);
  result := Integer(value.AsObject);
end;

function executeInstanceMethodReturnReferenceArgsString(const Reference
  : Integer; const AName, AValue: PAnsiChar): Integer; stdcall;
var
  value: TValue;
begin
  value := executeInstanceMethod(Reference, string(AName), [string(AValue)]);
  result := Integer(value.AsObject);
end;

function executeInstanceMethodReturnIntArgsString(const Reference: Integer;
  const AName, AValue: PAnsiChar): Integer; stdcall;
var
  value: TValue;
begin
  value := executeInstanceMethod(Reference, string(AName), [string(AValue)]);
  result := value.AsInteger;
end;

function executeInstanceMethodReturnIntArgsStringReference(const Reference
  : Integer; const AName, AValue: PAnsiChar; const R: Integer)
  : Integer; stdcall;
var
  value: TValue;
begin
  value := executeInstanceMethod(Reference, string(AName),
    [string(AValue), TObject(R)]);
  result := value.AsInteger;
end;

procedure executeInstanceMethodReturnStringArgsNone_Out_String
  (const Reference: Integer; const AName: PAnsiChar; out value: WideString); stdcall;
var
  methodResultValue: TValue;
begin
  methodResultValue := executeInstanceMethod(Reference, string(AName), []);
  value := methodResultValue.AsString;
end;

procedure executeInstanceMethodReturnEnumArgsNone(const Reference: Integer;
  const AName: PAnsiChar; out value: WideString); stdcall;
var
  s: String;
  methodResultValue: TValue;
begin
  methodResultValue := executeInstanceMethod(Reference, string(AName), []);
  s := methodResultValue.AsString;
  value := s;
end;

procedure executeClassMethodReturnNoneArgsStringStringString_Out_String
  (const AQualifiedName, AName: PAnsiChar; const v1, v2, v3: WideString;
  out value: WideString); stdcall;
var
  methodResultValue: TValue;
begin
  methodResultValue := executeClassMethod(string(AQualifiedName), string(AName),
    [string(v1), string(v2), string(v3)]);
  value := methodResultValue.AsString;
end;

end.
